#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	ReMake Face
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Misc Tool>ReMake Face
#		 Note:	
#			
#    Date:	
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item("ReMake Face") { SDM::ReMake_Face.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module ReMake_Face

		def self.main
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			unless sel.empty?
				mod.start_operation "ReMake Face"
				#
				edgs = []; rmv = []
				dir = UI.inputbox(['Sort by:'],['x'],['x|y|z'],'New Skin')
				case dir[0]
					when 'x'
						vts = sel.grep(Sketchup::Edge).map{|e|e.vertices}.flatten.uniq.sort{|a,b|a.position.x<=>b.position.x}
					when 'y'
						vts = sel.grep(Sketchup::Edge).map{|e|e.vertices}.flatten.uniq.sort{|a,b|a.position.y<=>b.position.y}
					when 'z'
						vts = sel.grep(Sketchup::Edge).map{|e|e.vertices}.flatten.uniq.sort{|a,b|a.position.z<=>b.position.z}
				end
				for i in 1...vts.length
					next if (vts[i].edges&vts[i-1].edges)[0]
					edg = ent.add_line vts[i-1].position,vts[i].position
					edg.find_faces;edg.soft=edg.smooth=true;edgs<<edg
				end
				edgs.each{|e|rmv<<e if e.faces[0].normal.samedirection?(e.faces[1].normal)}
				ent.erase_entities(rmv.reverse)
				#
				mod.commit_operation
			else
				UI.messagebox "Select 'Hole' outline first"
			end
		end
	end
end


